#!/usr/bin/env python
# -*- coding: utf-8 -*-
# File  : classifier.py

import random
import numpy as np
from sklearn.model_selection import train_test_split
from sklearn.linear_model import LogisticRegression
from sklearn.model_selection import StratifiedKFold,cross_val_predict
from sklearn.metrics import accuracy_score
from sklearn.svm import SVC
from sklearn.tree import DecisionTreeClassifier
from sklearn.ensemble import RandomForestClassifier
from sklearn.neighbors import KNeighborsClassifier
from sklearn.naive_bayes import GaussianNB
from xgboost import XGBClassifier
# path = r'.\temp_data\result'
from sklearn.preprocessing import StandardScaler
import warnings
import random
warnings.filterwarnings("ignore")

def classification(x_train, y_train, x_test, y_test):
	random.seed(1)
	models = [LogisticRegression(), KNeighborsClassifier(), SVC(class_weight='balanced'), DecisionTreeClassifier(),
			  GaussianNB(), XGBClassifier(), RandomForestClassifier(n_estimators=10)]
	models_str = ['LR', 'KNN', 'SVC', 'DT', 'GNB', 'XGBoost', 'RF']

	score_dict = {}

	for name, model in zip(models_str, models):

		model.fit(x_train, y_train)
		y_pred = model.predict(x_test)
		score = accuracy_score(y_pred, y_test)
		score_dict[name] = score

	return score_dict

# def IFS(df,y,ranked_features,clf_model, kfold):
# 	random.seed(1)
# 	features_list = []
# 	scores_ = []
# 	# 按照feature importances 排列的特征索引
# 	# x = df[ranked_features].values
#
# 	for i in ranked_features:
# 		features_list.append(i)
# 		ifs_x = df[features_list].values
# 		ifs_x = StandardScaler().fit_transform(ifs_x)
# 		skf = StratifiedKFold(n_splits=kfold)
# 		y_pred = cross_val_predict(clf_model, ifs_x, y, cv=skf)
# 		score = accuracy_score(y_pred, y)
# 		scores_.append(round(score,4))
# 	return scores_

