#!/usr/bin/env python
# -*- coding: utf-8 -*-
# File  : testMain.py.py

import FeatureSelection_Subset_V2 as fs
import classifier as clf
import pandas as pd
from sklearn.model_selection import train_test_split
from sklearn.preprocessing import StandardScaler

import os


def text_save(file_name,data):
	output = open(file_name,'w')
	# output.write('name\tgender\tstatus\tage\n')
	for i in range(len(data)):
		for j in range(len(data[i])):
			output.write(str(data[i][j]))
			output.write('\t')
		output.write('\n')
	output.close()


def fs_model(x,y,feature_names, selet_number, test_size):

	fmodels_str = ['SK_mic', 'SK_fdr', 'SK_fpr', 'RFE_SVC', 'RFE_LR', 'LinearSVC_L1', 'LR_L1', 'DT_gini', 'RF',
				   'AdaBoost', 'GB']
	# models = [LogisticRegression(), KNeighborsClassifier(), SVC(class_weight='balanced'), DecisionTreeClassifier(),
	# 		  GaussianNB(), XGBClassifier(), RandomForestClassifier(n_estimators=10)]
	# models_str = ['LR', 'KNN', 'SVC', 'DT', 'GNB', 'XGBoost', 'RF']
	#
	# model_dict = dict(zip(models_str, models))

	std = StandardScaler()

	X_train, X_test, y_train, y_test = train_test_split(x, y, test_size=test_size, random_state=42)
	std.fit_transform(X_train)
	X_train = std.transform(X_train)
	X_test = std.transform(X_test)


	index_dict, feature_name_dict = fs.invoking_feature_fuc(fmodels_str, X_train, y_train,
															feature_names, number=selet_number)
	score_dict = {}
	for i in index_dict:  # i feature selection methods
		x_train = X_train[:, index_dict[i]]
		x_test = X_test[:, index_dict[i]]

		score_model = clf.classification(x_train, y_train, x_test, y_test)
		score_dict[i] = score_model

	score_df = pd.DataFrame.from_dict(score_dict, orient='index')
	score_df = score_df.applymap(lambda x: round(x, 4))
	
	# os.makedirs(egDataFolderO,exists_ok=True)

	if not os.path.exists(egDataFolderO):
		os.makedirs(egDataFolderO)

	score_df.to_csv(egDataFolderO + '\Output-score.csv')
	pd.DataFrame.from_dict(feature_name_dict, orient='index').to_csv(egDataFolderO+'\Output-SelectedFeatures.csv')

	return


if __name__ == '__main__':

	import sys

	# print(len(sys.argv))

	if len(sys.argv) == 7: # combine=False
		egDataFileI  = sys.argv[1]
		egLabelFileI = sys.argv[2]
		egDataFolderO = sys.argv[3]

		number  = sys.argv[4]
		test_size = float(sys.argv[5])
		combine = sys.argv[6]

		if combine == 'False':

			x = pd.read_csv(egDataFileI, index_col=0)

			print('Model Start !')

			feature_names = list(x.columns)
			# print(feature_names)
			x = x.values
			print('Input data shape：', x.shape)
			y = pd.read_csv(egLabelFileI, index_col=0).values.ravel()
			print('Input label shape:', y.shape)
			if x.shape[0] == y.shape[0]:
				fs_model(x, y, feature_names, int(number), test_size)
				print('The two result files have written to the Output folder! ')
			else:
				print('Sample number not equal to label number')
				exit(-1)
		else:
			print("-Error in syntax!")
			print("If comine is True, please input combine file.")
			print(
				"python testMain.py <in-data-file.xlsx> <in-label-file.xlsx> <output folder> <select feature number> <test_size> <combine> <combine file>")
			exit(-1)

	elif len(sys.argv) == 8: # combine=False

		egDataFileI  = sys.argv[1]
		egLabelFileI = sys.argv[2]
		egDataFolderO = sys.argv[3]
		number  = sys.argv[4]
		test_size = float(sys.argv[5])
		combine = sys.argv[6]
		egDataMqI = sys.argv[7]

		x = pd.read_csv(egDataFileI, index_col=0)
		mq = pd.read_csv(egDataMqI, index_col=0)
		columns = list(x.columns)+['mq_'+i for i in list(mq.columns)]
		x = pd.concat((x, mq), axis=1)
		x.columns = columns

		print('Model Start !')

		feature_names = list(x.columns)
		# print(feature_names)
		x = x.values
		print('Input data shape：', x.shape)
		y = pd.read_csv(egLabelFileI, index_col=0).values.ravel()
		print('Input label shape:', y.shape)
		if x.shape[0] == y.shape[0]:
			fs_model(x, y, feature_names, int(number), test_size)
			print('The two result files have written to the Output folder! ')
		else:
			print('Sample number not equal to label number')
			exit(-1)

	else:
		print("-Error in syntax!")
		print(
			"python testMain.py <in-data-file.xlsx> <in-label-file.xlsx> <output folder> <select feature number> <test_size> <combine>")
		print("If comine is True, please input combine file.")
		print("python testMain.py <in-data-file.xlsx> <in-label-file.xlsx> <output folder> <select feature number> <test_size> <combine> <combine file>")
		exit(-1)

	print('The scores result has written to Output-score.xlsx')
	print(
		'The name of the selected feature of each feature selection method is written to Output-SelectedFeatures.xlsx')

