#!/usr/bin/env python
# -*- coding: utf-8 -*-
# File  : mqLoader.py
# Author: My Duan
# Date  : 2022-08-17

import numpy as np
import torch

def _make_R(y):
	R = np.zeros((y.shape[0], y.shape[0]))
	for i in range(y.shape[0]):
		for j in range(y.shape[0]):
			R[i,j] = (y[j] >=y[i])
	return R


def get_survival_loader(driver, target, y, edge_index, batch_size, drop_last=False):
	'''
	laod the graph classification data
	:return:
	'''

	from torch_geometric.data import Data
	from torch_geometric.loader import DataLoader

	# ['cencored' ,'survival', 'stratufied', 'idx']
	concat = np.hstack((target, y))
	idx = np.array(range(target.shape[0])).reshape(-1, 1)  # sample number
	concat = np.hstack((concat, idx))

	graph_list = [Data(x=torch.tensor(driver[i].reshape(-1, 1), dtype=torch.float),
						  edge_index=torch.tensor(edge_index, dtype=torch.long),
						  y=torch.tensor(concat[i].reshape(1, -1), dtype=torch.float)) for i in
					 range(driver.shape[0])]

	data_loader = DataLoader(graph_list, batch_size=batch_size, shuffle=False, drop_last=drop_last)

	return data_loader


def get_gat_loader(driver, target, edge_index, batch_size):
	'''
	:return:
	'''

	'''WGCNA construct the adacency matrix'''

	'''Get the adj information and construct the graph loader'''

	from torch_geometric.data import Data
	from torch_geometric.loader import DataLoader

	graph_list = [
		Data(x=torch.tensor(driver[i].reshape(-1,1), dtype=torch.float),
			 edge_index=torch.tensor(edge_index, dtype=torch.long),
			 y=torch.tensor(target[i].reshape(1,-1), dtype=torch.float)) for i in range(target.shape[0])
	]
	data_loader = DataLoader(graph_list, batch_size=batch_size, shuffle=True)

	return data_loader







