#!/usr/bin/env python
# -*- coding: utf-8 -*-
# File  : DQSurv_mq.py
# Author: My Duan
# # Date  : 2023-07-23
# from preprocess import *
from options import parse_args
from data_loader import *
import pandas as pd
import math

opt = parse_args()

def mqTrans(obj_data, survival_label, driver, target, edge_index,
		   pretrained_model_path, model_path):

	data_targ_df = obj_data.loc[:, target]
	data_targ_df = data_targ_df.fillna(0)
	# print(data_targ_df.shape)
	data_targ_df.to_csv(model_path + '/test_target.csv')

	print('Targets true values have been saved in ./output.')

	print('\nModeling ...')

	print('KNN imputation...')
	from sklearn.impute import KNNImputer
	imputer = KNNImputer()
	imputer.fit(obj_data)
	data_impute = imputer.transform(obj_data)

	print('Z-normlization...')
	from sklearn.preprocessing import StandardScaler
	std = StandardScaler()
	data_std = std.fit_transform(data_impute)

	data_df = pd.DataFrame(data_std, index=obj_data.index.to_list(), columns=obj_data.columns.to_list())

	data_driver = data_df.loc[:, driver].values
	data_targ = data_df.loc[:, target].values

	data_dl =  get_survival_loader(data_driver, data_targ, survival_label, edge_index, batch_size=1000, drop_last=False)
	
	pretrained_model = torch.load(pretrained_model_path).to(opt.device)

	for idx, batch_loader in enumerate(data_dl):
		# print(idx)
		pred_targ = pretrained_model(batch_loader)
		pred_targ = pred_targ.detach().cpu().numpy()
		x, adj, batch = batch_loader.x.to(opt.device), batch_loader.edge_index.to(opt.device), batch_loader.batch.to(opt.device)

	n_col = [obj_data.columns.to_list().index(i) for i in target]
	pred_targ = pred_targ * std.var_[n_col] + std.mean_[n_col]
	pred_targ_df = pd.DataFrame(pred_targ, columns=target, index=data_df.index)
	pred_targ_df.to_csv(model_path + '/pred_targets.csv')
	print('Targets prediction values have been saved in ./output.')

	mq = pred_targ_df - data_targ_df
	mq.to_csv(model_path + '/mq_targets.csv')
	print('Targets mqvalues have been saved in ./output.')



