#!/usr/bin/env python
# -*- coding: utf-8 -*-
# File  : utils.py
# Author: My Duan
# Date  : 2022-09-30

import sys
import pandas as pd
import numpy as np
import torch
import copy

class Logger(object):
	def __init__(self, file_path: str = "./Default.log"):
		self.terminal = sys.stdout
		self.log = open(file_path, "a")

	def write(self, message):
		self.terminal.write(message)
		self.log.write(message)

	def flush(self):
		pass


def transform_na(data: pd.DataFrame, missing_value)-> pd.DataFrame:

	if missing_value == '-9.9658':
		missing_value = float(missing_value)
		thre = 1e-5
		na_data = data.applymap(lambda x: np.nan if x - missing_value < thre else x)
		return na_data

	if missing_value == '0.0':
		missing_value = float(missing_value)
		na_data = data.applymap(lambda x: np.nan if x ==0.0 else x)
		return na_data

	if missing_value == ' ':
		return data

	if missing_value == 'no':
		return data

	else:
		print('We do not support this missing value! Please fill it yourself.')







